import _extends from 'babel-runtime/helpers/extends';
import _Object$keys from 'babel-runtime/core-js/object/keys';
import createInstance from './createInstance';
import makeActionCreator from './makeActionCreator';

/**
 * Create Redux actions from Class or object
 * @param {Class|Object} Actions
 * @param {String} [typePrefix]
 * @return {Object} Action creators
 */
export default function createActions(Actions, typePrefix) {
  var actions = createInstance(Actions);

  return _Object$keys(actions).reduce(function (result, name) {
    var _extends2;

    return _extends({}, result, (_extends2 = {}, _extends2[name] = makeActionCreator(typePrefix, name, actions[name]), _extends2));
  }, {});
}