import _extends from 'babel-runtime/helpers/extends';
import identity from 'lodash/identity';
import isFunction from 'lodash/isFunction';
import getInternalMethods from '../utils/getInternalMethods';

export default function createInstance(Actions) {
  if (!isFunction(Actions)) return Actions;

  var actions = getInternalMethods(Actions);

  /* eslint-disable no-param-reassign */

  /**
   * Creates actions by their names
   * @param {...string} actionNames
   */
  Actions.prototype.generate = function generate() {
    for (var _len = arguments.length, actionNames = Array(_len), _key = 0; _key < _len; _key++) {
      actionNames[_key] = arguments[_key];
    }

    actionNames.forEach(function (actionName) {
      actions[actionName] = identity;
    });
  };

  /* eslint-enable no-param-reassign */

  return _extends({}, actions, new Actions());
}