import identity from 'lodash/identity';
import isFunction from 'lodash/isFunction';
import getTypePrefix from '../utils/getTypePrefix';
import toConstant from '../utils/toConstant';

export default function makeAction(prefix, name, payload) {
  var type = '' + getTypePrefix(prefix) + toConstant(name);
  var finalPayload = isFunction(payload) ? payload : identity;

  var action = function action() {
    return {
      type: type, payload: finalPayload.apply(undefined, arguments)
    };
  };

  action.toString = function () {
    return type;
  };

  return action;
}