import reduceReducers from 'reduce-reducers';
import createInstance from './createInstance';

/**
 * Create Redux reducer from Class
 * @param {Class|Object} Reducer
 * @param {Object} [initialState]
 * @param {String} [typePrefix]
 * @return {Function} Reducer
 */
export default function createReducer(Reducer, initialState, typePrefix) {
  var _createInstance = createInstance(Reducer, typePrefix),
      reducers = _createInstance.reducers,
      reducerInitialState = _createInstance.initialState;

  var reducer = reduceReducers.apply(undefined, reducers);

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState || reducerInitialState;
    var action = arguments[1];
    return reducer(state, action);
  };
}