'use strict';

exports.__esModule = true;

var _extends3 = require('babel-runtime/helpers/extends');

var _extends4 = _interopRequireDefault(_extends3);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.default = createActions;

var _createInstance = require('./createInstance');

var _createInstance2 = _interopRequireDefault(_createInstance);

var _makeActionCreator = require('./makeActionCreator');

var _makeActionCreator2 = _interopRequireDefault(_makeActionCreator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Create Redux actions from Class or object
 * @param {Class|Object} Actions
 * @param {String} [typePrefix]
 * @return {Object} Action creators
 */
function createActions(Actions, typePrefix) {
  var actions = (0, _createInstance2.default)(Actions);

  return (0, _keys2.default)(actions).reduce(function (result, name) {
    var _extends2;

    return (0, _extends4.default)({}, result, (_extends2 = {}, _extends2[name] = (0, _makeActionCreator2.default)(typePrefix, name, actions[name]), _extends2));
  }, {});
}