'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = createInstance;

var _identity = require('lodash/identity');

var _identity2 = _interopRequireDefault(_identity);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _getInternalMethods = require('../utils/getInternalMethods');

var _getInternalMethods2 = _interopRequireDefault(_getInternalMethods);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createInstance(Actions) {
  if (!(0, _isFunction2.default)(Actions)) return Actions;

  var actions = (0, _getInternalMethods2.default)(Actions);

  /* eslint-disable no-param-reassign */

  /**
   * Creates actions by their names
   * @param {...string} actionNames
   */
  Actions.prototype.generate = function generate() {
    for (var _len = arguments.length, actionNames = Array(_len), _key = 0; _key < _len; _key++) {
      actionNames[_key] = arguments[_key];
    }

    actionNames.forEach(function (actionName) {
      actions[actionName] = _identity2.default;
    });
  };

  /* eslint-enable no-param-reassign */

  return (0, _extends3.default)({}, actions, new Actions());
}