'use strict';

exports.__esModule = true;
exports.default = makeAction;

var _identity = require('lodash/identity');

var _identity2 = _interopRequireDefault(_identity);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _getTypePrefix = require('../utils/getTypePrefix');

var _getTypePrefix2 = _interopRequireDefault(_getTypePrefix);

var _toConstant = require('../utils/toConstant');

var _toConstant2 = _interopRequireDefault(_toConstant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function makeAction(prefix, name, payload) {
  var type = '' + (0, _getTypePrefix2.default)(prefix) + (0, _toConstant2.default)(name);
  var finalPayload = (0, _isFunction2.default)(payload) ? payload : _identity2.default;

  var action = function action() {
    return {
      type: type, payload: finalPayload.apply(undefined, arguments)
    };
  };

  action.toString = function () {
    return type;
  };

  return action;
}