'use strict';

exports.__esModule = true;
exports.default = createReducer;

var _reduceReducers = require('reduce-reducers');

var _reduceReducers2 = _interopRequireDefault(_reduceReducers);

var _createInstance2 = require('./createInstance');

var _createInstance3 = _interopRequireDefault(_createInstance2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Create Redux reducer from Class
 * @param {Class|Object} Reducer
 * @param {Object} [initialState]
 * @param {String} [typePrefix]
 * @return {Function} Reducer
 */
function createReducer(Reducer, initialState, typePrefix) {
  var _createInstance = (0, _createInstance3.default)(Reducer, typePrefix),
      reducers = _createInstance.reducers,
      reducerInitialState = _createInstance.initialState;

  var reducer = _reduceReducers2.default.apply(undefined, reducers);

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState || reducerInitialState;
    var action = arguments[1];
    return reducer(state, action);
  };
}