'use strict';

exports.__esModule = true;
exports.default = makeActionHandler;

var _getTypePrefix = require('../utils/getTypePrefix');

var _getTypePrefix2 = _interopRequireDefault(_getTypePrefix);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function makeActionHandler(reducerHandler, prefix, actionType, initialState) {
  var actionCreatorType = '' + (0, _getTypePrefix2.default)(prefix) + actionType;

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments[1];
    return actionCreatorType === action.type ? reducerHandler(state, action.payload) : state;
  };
}