import createInstance from './createInstance';
import makeActionCreator from './makeActionCreator';

/**
 * Create Redux actions from Class or object
 * @param {Class|Object} Actions
 * @param {String} [typePrefix]
 * @return {Object} Action creators
 */
export default function createActions(Actions, typePrefix) {
  const actions = createInstance(Actions);

  return Object.keys(actions).reduce((result, name) => ({
    ...result, [name]: makeActionCreator(typePrefix, name, actions[name])
  }), {});
}
