import identity from 'lodash/identity';
import isFunction from 'lodash/isFunction';
import getTypePrefix from '../utils/getTypePrefix';
import toConstant from '../utils/toConstant';

export default function makeAction(prefix, name, payload) {
  const type = `${getTypePrefix(prefix)}${toConstant(name)}`;
  const finalPayload = isFunction(payload) ? payload : identity;

  const action = (...args) => ({
    type, payload: finalPayload(...args)
  });

  action.toString = () => type;

  return action;
}
