import reduceReducers from 'reduce-reducers';
import createInstance from './createInstance';

/**
 * Create Redux reducer from Class
 * @param {Class|Object} Reducer
 * @param {Object} [initialState]
 * @param {String} [typePrefix]
 * @return {Function} Reducer
 */
export default function createReducer(Reducer, initialState, typePrefix) {
  const { reducers, initialState: reducerInitialState } = createInstance(Reducer, typePrefix);
  const reducer = reduceReducers(...reducers);

  return (state = (initialState || reducerInitialState), action) => reducer(state, action);
}
